"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOAuth = void 0;
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const wouter_1 = require("wouter");
const slice_1 = require("@procyon/auth/slice");
const actions_1 = require("../actions");
const generateState = () => 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    const r = (Math.random() * 16) | 0, v = c == 'x' ? r : (r & 0x3) | 0x8;
    return v.toString(16);
});
const useOAuth = ({ baseUrl, clientId, authEndpoint, tokenEndpoint, redirectUri }) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const [, setLocation] = (0, wouter_1.useLocation)();
    const redirect = (0, react_1.useCallback)(() => {
        const state = generateState();
        const urlParams = {
            client_id: clientId,
            redirect_uri: redirectUri,
            response_mode: 'fragment',
            response_type: 'code',
            scope: 'openid profile',
            state,
        };
        const conectionURI = new URL(`${baseUrl}${authEndpoint}`);
        for (const key of Object.keys(urlParams)) {
            conectionURI.searchParams.append(key, urlParams[key]);
        }
        window.location.assign(conectionURI);
    }, []);
    const obtainTokens = (0, react_1.useCallback)((code) => __awaiter(void 0, void 0, void 0, function* () {
        const { data: tokens } = yield (0, actions_1.fetchTokens)({
            baseUrl,
            tokenEndpoint,
            clientId,
            redirectUri: redirectUri,
            grantType: 'authorization_code',
            code,
        });
        if (tokens) {
            dispatch((0, slice_1.setAuthTokens)({
                accessToken: tokens.access_token,
                refreshToken: tokens.refresh_token,
                idToken: tokens.id_token,
                accessExpiresIn: tokens.expires_in,
                refreshExpiresIn: tokens.refresh_expires_in,
                sessionState: tokens.session_state,
            }));
            setLocation('/');
        }
    }), []);
    return {
        redirect,
        obtainTokens,
    };
};
exports.useOAuth = useOAuth;
